C-----------------------------------------------------------------------
C VLBINC:FITS1.INC -- include file for FITS_ routines
C-----------------------------------------------------------------------
C
C     BUFF     Is used to build up the 'line' for a single
C              header keyword.
C     MTERR    Holds the error description for the last MTPCKG
C              error code.
C     FBUFF    Is the main I/O buffer, (2880 bytes) defined as a
C              byte array.
C     FBUFFS   Is the same as FBUFF, but is defined as a word array.
C     FBUFFI   Is the same as FBUFF, but defined as a longword array.
C     FPTR     Points to the next available byte in FBUFF.
C     MTUNIT   Is the MTPCKG ID code for the tape drive in use.
C     MTSTAT   Is the last MTPCKG I/O error code.
C-----------------------------------------------------------------------
      CHARACTER BUFF*80,MTERR*64
      COMMON /FIG_COMB/ BUFF,MTERR
      BYTE FBUFF(2880)
      INTEGER*2 FBUFFS(1440)
      INTEGER FBUFFI(720)
      INTEGER FPTR,MTUNIT,MTSTAT,BLKNO
      COMMON /FIT_COMF/ FPTR,MTUNIT,MTSTAT,BLKNO,FBUFF
      EQUIVALENCE (FBUFFS(1),FBUFF(1)),(FBUFFI(1),FBUFF(1))
C-----------------------------------------------------------------------
