      SUBROUTINE FITS_BUFP (NAME,COMMENT)
C-----------------------------------------------------------------------
C     Writes NAME and COMMENT into the header line buffer BUFF
C     and sets the rest of BUFF blank.
C
C     Parameters -  (">" input, "<" output)
C
C     (>) NAME       (Character) The keyword name
C     (>) COMMENT    (Character) The associated comment
C
C     Note: NAME will be written into BUFF converted to upper case, but
C     COMMENT will be copied over as passed.
C
C     Common variables used -
C
C     (<) BUFF       (Character) Buffer for one header line
C
C     Subroutines / functions used - 
C
C     UPCASE         Convert string to upper case.
C
C                                    KS / CIT 9th Oct 1983
C-----------------------------------------------------------------------
C
      CHARACTER*(*) NAME,COMMENT
C
      INCLUDE 'fits1.inc'
C
      BUFF=NAME
      CALL UPCASE(BUFF(1:8))
      BUFF(9:9)='='
      BUFF(32:32)='/'
      BUFF(34:)=COMMENT
C
      END
