      SUBROUTINE FITS_CLOSE (STATUS)
C-----------------------------------------------------------------------
C     Should be the last FITS_ routine called during the writing
C     of a single image.  Flushes the main I/O buffer to disk,
C     and closes the output file.
C
C     Parameters -  (">" input, "W" workspace, "<" output, "!" modified)
C
C     (<) STATUS    (Integer) Returned status code. 0 => OK, non-zero
C                   codes are I/O error codes, which may be decoded
C                   by FITS_ERROR.
C
C     Subroutines / functions used -
C
C     FITS_FLUSH    (FITS_ package) Writes FBUFF to output file.
C
C                                       KS/TJP / CIT 11th Oct 1983
C-----------------------------------------------------------------------
C
      INTEGER STATUS
C
      INCLUDE 'fits1.inc'
C
C     Flush if necessary.
C
      CALL FITS_FLUSH(STATUS)
      IF (STATUS.NE.0)  GO TO 600
C
C     Close file.
C
      CLOSE (UNIT=MTUNIT, IOSTAT=STATUS)
C
  600 CONTINUE
      END
