C-----------------------------------------------------------------------
C VLBINC:MERGE61.INC : Include file for VLBMERGE Array Configuration.
C-----------------------------------------------------------------------
C MAXS   : maximum number of stations
C MAXB   : maximum number of baselines
C MAXT   : maximum number of closure triangles
C LABELB : baseline labels  100*I1 + I2  for baseline I1-I2
C LABELT : triangle lables  10000*I1 + 100*I2 +I3
C CONST  : baseline numbers of the 3 sides of each triangle
C-----------------------------------------------------------------------
      INTEGER        MAXS, MAXB, MAXT
      PARAMETER      (MAXS = 30)
      PARAMETER      (MAXB = MAXS*(MAXS-1)/2)
      PARAMETER      (MAXT = MAXB*(MAXS-2)/3)
      INTEGER        LABELB(MAXB), LABELT(MAXT), CONST(MAXT,3)
      COMMON /MRG01/ LABELB, LABELT, CONST
C-----------------------------------------------------------------------
