C        INCLUDE FILE FOR BASELINE PLOTTING SECTION OF VLBPLOT.
C
C
C
C      PLOT BORDERS AND LABELS  --  BASELINES
C
      CALL TSCALE(BTMIN,BTMAX,INHRB,LEFT,RIGHT,MAXWID,MINWID,HR5,TIMEA,
     +        XCENTER)
C     
C     FOR TEK SCREENS - SPREAD SCALE TO FILL SCREEN
C    
      WR = 1.0
      XPER = XPERIN
      XADR = 0.0
      IF(TYPE.EQ.3) THEN
         WID = RIGHT - LEFT
         WR = WID/MAXWID
         XPER = XPERIN / WR
         XADR = (XPERIN - XPER)*XCENTER
      END IF
C
      IF(SETWIDTH) THEN
	 WID = RIGHT - LEFT
	 WR = WID/SETW
         XPER = XPERIN / WR
         XADR = (XPERIN - XPER)*XCENTER
      END IF
C
      NPLOT = 0
      IONPG = 0
   80 NPLOT = NPLOT + 1
      DO 81 IB = 1,NB
      IF(MB1(NPLOT).EQ.NB1(IB).AND.MB2(NPLOT).EQ.NB2(IB)) GO TO 82
   81 CONTINUE
         WRITE(6,1020) MB1(NPLOT),MB2(NPLOT)
 1020    FORMAT('0 Baseline (',I2,',',I2,') not found')
         STOP 
C
   82 CONTINUE
      IF(UTBMIN(NPLOT).EQ.9999.) THEN
         WRITE(6,1021) MB1(NPLOT),MB2(NPLOT)
 1021    FORMAT('  No data for baseline (',I2,',',I2,')  ')
C                                Add bottom label if needed
         IF(NPLOT.EQ.NBP.AND.IONPG.NE.NPAGE.AND.IONPG.GT.0)  THEN
            IF(TIMEA.EQ.HIHA) STIME = SIHA 
            IF(TIMEA.EQ.HGST) STIME = SGST
            IF(TIMEA.EQ.HUT.OR.TIMEA.EQ.HUTMOD) STIME = SUT
            CALL GRCHAR(IDEVICE,.FALSE.,0.0,.FALSE.,
     +            XCENTER-14.*HTLET*WR,BOT-3.5*HTLET,STIME)
            IPLAB = 1
            CALL BORDER(RIGHT,LEFT,IPLAB,HTPLOT,BOT,HTTICK,
     +                  HTLET,WR,IDEVICE)
          CALL GRTERM(IDEVICE)
C	write y-axis labels
         X = (RIGHT+8.0*HTLET*WR) *XPER + XADR
         Y = YSZDEF-9.0*HTLET*YPERIN-(IONPG)*HTPLOT*YPERIN/2.0
         IF(COEFF) SCOEFF = SCC
         IF(.NOT.COEFF) SCOEFF = SCF
         IF(IUNITS.EQ.2) SCOEFF = SFR
         IF(IUNITS.EQ.3) SCOEFF = SDL
         IF(SNR) SCOEFF = SCS
C
         IF(COEFF.AND.MODEL) THEN
	 IF(Y .GT. YSZDEF-15.0*HTLET*YPERIN) Y=YSZDEF-15.0*HTLET*YPERIN
         CALL GRCHAR(IDEVICE,.FALSE.,90.,.TRUE.,X,Y,SMF)
	 ENDIF
C
         X = (LEFT-8.0*HTLET*WR) *XPER + XADR
         Y = Y - 7.0*HTLET*YPERIN
	 IF(Y .GT. YSZDEF-25.0*HTLET*YPERIN) THEN
	  Y=YSZDEF-25.0*HTLET*YPERIN
	  IF (SCOEFF .EQ. SCF) Y=YSZDEF-22.0*HTLET*YPERIN
	 ENDIF
         CALL GRCHAR(IDEVICE,.FALSE.,90.0,.TRUE.,X,Y,SCOEFF)
C
          CALL GRTERM(IDEVICE)
         END IF
          GO TO 251
      ELSE                       !  Plot it.
         IONPG = IONPG + 1
      END IF
C
C
C     PAUSE IF PLOTTING ON TEK SCREEN
C
      IF(TYPE.EQ.3.AND.NEWPAGE) THEN
         CALL VISBEL
         NEWPAGE = .FALSE.
      END IF
C
C
C
C     SET UP PLOT AREA
C
      IONPG = MOD(IONPG,NPAGE)
      IF(IONPG.EQ.0) IONPG = NPAGE
      IF(IONPG.EQ.1) CALL GRPAGE(IDEVICE)
      YADD = (NPAGE-IONPG) * HTPLOT * YPERIN  
      CALL GRTRAN(IDEVICE,XADR,YADD,XPER,YPERIN)
C
C
      IPLAB = 0
      IF(IONPG.EQ.NPAGE.OR.NPLOT.EQ.NBP) IPLAB = 1
      CALL BORDER(RIGHT,LEFT,IPLAB,HTPLOT,BOT,HTTICK,HTLET,WR,IDEVICE)
      IF(IONPG.EQ.NPAGE.OR.NPLOT.EQ.NBP) THEN
         IF(TIMEA.EQ.HIHA) STIME = SIHA 
         IF(TIMEA.EQ.HGST) STIME = SGST
         IF(TIMEA.EQ.HUT.OR.TIMEA.EQ.HUTMOD) STIME = SUT
         CALL GRCHAR(IDEVICE,.FALSE.,0.0,.FALSE.,XCENTER-14.*HTLET*WR,
     +            BOT-3.5*HTLET,STIME)
C	write y-axis labels
         X = (RIGHT+8.0*HTLET*WR) *XPER + XADR
         IF(IONPG.EQ.NPAGE) THEN
	   Y = YSZDEF/2.0 - 5.0*HTLET*YPERIN
	 ELSE
         Y = YSZDEF-9.0*HTLET*YPERIN-(IONPG)*HTPLOT*YPERIN/2.0
	 ENDIF
         IF(COEFF) SCOEFF = SCC
         IF(.NOT.COEFF) SCOEFF = SCF
         IF(IUNITS.EQ.2) SCOEFF = SFR
         IF(IUNITS.EQ.3) SCOEFF = SDL
         IF(SNR) SCOEFF = SCS

         IF(COEFF.AND.MODEL) THEN
	 IF(Y .GT. YSZDEF-15.0*HTLET*YPERIN) Y=YSZDEF-15.0*HTLET*YPERIN
         CALL GRCHAR(IDEVICE,.FALSE.,90.,.TRUE.,X,Y,SMF)
	 ENDIF
C
         X = (LEFT-8.0*HTLET*WR) *XPER + XADR
         Y = Y - 7.0*HTLET*YPERIN
	 IF(Y .GT. YSZDEF-25.0*HTLET*YPERIN) THEN
	  Y=YSZDEF-25.0*HTLET*YPERIN
	  IF (SCOEFF .EQ. SCF) Y=YSZDEF-22.0*HTLET*YPERIN
	 ENDIF
         CALL GRCHAR(IDEVICE,.FALSE.,90.0,.TRUE.,X,Y,SCOEFF)
C
      END IF
C
      IF(ASCALE.EQ.0.D0) THEN
         CALL SCALE(AMPMAX(NPLOT),HTSCAL,NTICKS,INCHJY(NPLOT))
      ELSE
         CALL SCALE(ASCALE,HTSCAL,NTICKS,INCHJY(NPLOT))
      END IF
C
      IF (IUNITS.EQ.2 .OR. IUNITS.EQ.3) THEN
       CALL FTICKS(RIGHT,LEFT,BOT+HTSCAL/2.0,HTLET,HTTICK,HTSCAL/2.0,
     +             NTICKS,WR,IDEVICE)
       CALL FTICKS(RIGHT,LEFT,BOT+HTSCAL/2.0,HTLET,HTTICK,-HTSCAL/2.0,
     +             NTICKS,WR,IDEVICE)
      ELSE
      CALL FTICKS(RIGHT,LEFT,BOT,HTLET,HTTICK,HTSCAL,NTICKS,WR,IDEVICE)
      END IF
C
C                                  Label baseline.
      YLAB = BOT + HTPLOT - 2.5*HTLET
      XLAB = LEFT + 2.0*HTLET
      CALL VSTR(STLAB,2,STNAME(MB1(NPLOT)),STNAME(MB2(NPLOT)), 0D0, 0D0)
      CALL GRCHAR(IDEVICE,.FALSE.,0.0,.FALSE.,XLAB,YLAB,STLAB)
C
      IF(IONPG.EQ.1) THEN
         X = LEFT
         Y = BOT + HTPLOT
         CALL HLAB(X,Y,HTLET,SOURCE,MONTH,IDAY,IYEAR,FLUX,FREQ,IDEVICE)
C
C                                     Write file names and warnings
         IF(.NOT.NOTEXT) THEN
            CALL GRCHAR(IDEVICE,.FALSE.,90.0,.TRUE.,
     +               HTLET*1.5*XPERIN,HTLET*3.*YPERIN,WDATA)
            IF(MODEL) CALL GRCHAR(IDEVICE,.FALSE.,90.0,.TRUE.,
     +            HTLET*3.5*XPERIN,HTLET*3.*YPERIN,WMODEL)
            IF(TIMEA.EQ.HUTMOD.AND.MODEL.AND.UTMAX-UTMIN.GT.24.0) THEN      
              WWARN='Model and data will not coincide after first day.'
              WWARN(53:)='Use UT, GST, or IHA for match.'
              CALL GRCHAR(IDEVICE,.FALSE.,90.0,.FALSE.,
     +                   (XINMAX-HTLET)*XPERIN,HTLET*3.*YPERIN,WWARN)
            END IF          
         END IF
      END IF
      CALL GRTERM(IDEVICE)	! Plot box etc. now
C
C     READ AMPLITUDES
C
  201    ND = 0
      NR = 0
      DO 205 ID = 1,MAXMOD
         READ(INDAT,END=250) IT,(TAKE(I),I=1,NWORDS)
         NR = NR + 1
         IF(IT.EQ.-1) GO TO 250
         UT = (IT-IZERO)/(60.*3600.)
         IF (UT.LT.UTMIN0) GO TO 205
         IF (UT.GT.UTMAX0) GO TO 205
         ND = ND + 1
         T(ND) = UT
         IUT(ND) = IT
         K = NDWPB*(IB-1)
         AMP(ND,1) = TAKE(K+1)
C        USE AMP(X,2) TO STORE ERRORS
         AMP(ND,2) = TAKE(K+2)
         IF(IUNITS.EQ.2 .OR. IUNITS.EQ.3) THEN
            AMP(ND,1) = ( AMP(ND,1) + HTSCAL/INCHJY(NPLOT) )/2.0
            AMP(ND,2) = AMP(ND,2) / 2.0
         END IF
C
C        COMPUTE SNR AND ITS ERROR (+/- 1.0) IF REQUESTED
	 IF (SNR.AND.(AMP(ND,2).NE.0.0)) THEN
            EBAR = ABS(AMP(ID,2))
	    AMP(ND,1) = AMP(ND,1)/EBAR
	    AMP(ND,2) = AMP(ND,2)/EBAR
	 END IF
  205    CONTINUE
C		Modified TJP 23-Mar-1983
  250	IF (NR.NE.0) THEN
      	    DO 218 ID=1,ND
                EBAR = AMP(ID,2)
		IF (EBAR.EQ.0.0) GO TO 218
		IF ((.NOT.PLOTDEL).AND.(EBAR.LT.0.0)) GO TO 218
                IF (EBAR.GT.0.0) THEN
	            CALL GRSCI(COLOR(2)) 	! Draw visibility data in COLOR(2)
                ELSE
	            CALL GRSCI(2)	 	! Draw deleted data in red
                END IF
                IF (NOERR) EBAR = 0.0
		CALL ATIME(T(ID),TT,IB,1)
		X = XCENTER - (HR5 - TT) * INHRB
		CALL GRMOVA(X,(AMP(ID,1)-EBAR)*INCHJY(NPLOT)+BOT)
		CALL GRLINA(X,(AMP(ID,1)+EBAR)*INCHJY(NPLOT)+BOT)
  218	    CONTINUE
	    CALL GRSCI(COLOR(1))		! Reset to cyan
	    CALL GRTERM(IDEVICE)	! Plot data now
	END IF
C
      IF(NR.EQ.MAXMOD) GO TO 201
C
C     MODEL
C
      IF(.NOT.MODEL) GO TO 120
C
      IF (MB1(NPLOT).EQ.NPLTMS(1) .OR. MB2(NPLOT).EQ.NPLTMS(1)
     + .OR. MB1(NPLOT).EQ.NPLTMS(2) .OR. MB2(NPLOT).EQ.NPLTMS(2))
     +  GOTO 120
C
	 CALL GRSCI(COLOR(3))		! Draw model in white
         MAX24 = .TRUE.
         IF(TIMEA.EQ.HUT) MAX24 = .FALSE.
         CALL MODCAL(INMOD,MB1(NPLOT),MB2(NPLOT),0,MAX24,MODPTS)
C        RETURN TIMING TO ORIGINAL AXIS UNITS
         CALL TIMING(TIMEA,TIMEC)
C
         IPEN = 13
C
C        SCALE MODEL PLOT DIFFERENTLY FROM DATA PLOT IF COEFF = TRUE
C
         BIJ = INCHJY(NPLOT)
         IF(.NOT.COEFF) GO TO 110
            AMT = 0.0
            DO 100 IT = 1,MODPTS
               IF(T(IT).LT.UTBMIN(NPLOT).OR.T(IT).GT.UTBMAX(NPLOT)) 
     +             GO TO 100
               IF(AMP(IT,1).GT.AMT) AMT = AMP(IT,1)
  100         CONTINUE
            CALL SCALE(AMT,HTSCAL,NTICKS,BIJ)
            DO 101 I = 1,NTICKS
               XX = RIGHT - 0.2*HTLET*WR 
               YY = BOT + I*HTSCAL/NTICKS - 0.5*HTLET
              CALL PRTNUM(XX,YY,HTLET,VALS(I),FMTT,0.,IDEVICE)
  101          CONTINUE
  110    CONTINUE
C
C
         DO 118 IT = 1,MODPTS
         CALL ATIME(T(IT),TT,IB,1)
         IF(TT.GT.BTBMIN(NPLOT).AND.TT.LT.BTBMAX(NPLOT)) GO TO 116
            IPEN = 13
            GO TO 118
  116      CONTINUE
            IF(AMP(IT,1)*BIJ .LT. HTPLOT) GO TO 117
               IPEN = 13
               GO TO 118
  117      CONTINUE
         XX = XCENTER - (HR5-TT) * INHRB
         CALL SYSPLT(XX,AMP(IT,1)*BIJ+BOT,IPEN,IDEVICE)
            IPEN = 12
  118      CONTINUE
	 CALL GRSCI(COLOR(1))	! Reset to cyan after plotting model
	 CALL GRTERM(IDEVICE)	! Plot model now
  120    CONTINUE
C
  251 CONTINUE
      REWIND INDAT
      CALL HEADX20(SKIPH,INDAT,IDU,IDU,IDU,IDU,IDU,IDU,IDU,XDUM,IDU,IDU)
      IF(NPLOT.GE.NBP.AND..NOT.(DOPHASE.OR.DOCLOSE.OR.DOCLAMP)) 
     *       GO TO 220
C
C
C     END OF BASELINES LOOP - RETURN FOR NEXT BASELINE
C
      IF(IONPG.EQ.NPAGE.OR.NPLOT.EQ.NBP) NEWPAGE = .TRUE.
      IF(NPLOT.GE.NBP) GO TO 220
      GO TO 80
C
