C        INCLUDE FILE FOR PHASE PLOTTING SECTION OF VLBPLOT.
C
C
C
C      PLOT BORDERS AND LABELS  --  PHASES
C
      CALL TSCALE(BTMIN,BTMAX,INHRB,LEFT,RIGHT,MAXWID,MINWID,HR5,TIMEA,
     +        XCENTER)
C     
C     FOR TEK SCREENS - SPREAD SCALE TO FILL SCREEN
C    
      WR = 1.0
      XPER = XPERIN
      XADR = 0.0
      IF(TYPE.EQ.3) THEN
         WID = RIGHT - LEFT
         WR = WID/MAXWID
         XPER = XPERIN / WR
         XADR = (XPERIN - XPER)*XCENTER
      END IF
C
      IF(SETWIDTH) THEN
	 WID = RIGHT - LEFT
	 WR = WID/SETW
         XPER = XPERIN / WR
         XADR = (XPERIN - XPER)*XCENTER
      END IF
C
      NPLOT = 0
      IONPG = 0
      IF(PSCALE.EQ.0.0) THEN
         INCHDG = HTPLOT/360.0
      ELSE
         INCHDG = HTPLOT/(2.0*PSCALE)
      END IF
C
  780 NPLOT = NPLOT + 1
      DO 781 IB = 1,NB
      IF(MB1(NPLOT).EQ.NB1(IB).AND.MB2(NPLOT).EQ.NB2(IB)) GO TO 782
  781 CONTINUE
         WRITE(6,1720) MB1(NPLOT),MB2(NPLOT)
 1720    FORMAT('0 baseline (',I2,',',I2,') not found')
         STOP 
C
  782 CONTINUE
      IF(UTBMIN(NPLOT).EQ.9999.) THEN
         WRITE(6,1721) MB1(NPLOT),MB2(NPLOT)
 1721    FORMAT('  No data for baseline (',I2,',',I2,')  ')
C                                  Add bottom label if needed.
         IF(NPLOT.EQ.NBP.AND.IONPG.NE.NPAGE.AND.IONPG.GT.0) THEN
            IF(TIMEA.EQ.HIHA) STIME = SIHA 
            IF(TIMEA.EQ.HGST) STIME = SGST
            IF(TIMEA.EQ.HUT.OR.TIMEA.EQ.HUTMOD) STIME = SUT
            CALL GRCHAR(IDEVICE,.FALSE.,0.0,.FALSE.,
     +           XCENTER-14.*HTLET*WR,BOT-3.5*HTLET,STIME)
            IPLAB = 1
            CALL BORDER(RIGHT,LEFT,IPLAB,HTPLOT,BOT, 
     +                  HTTICK,HTLET,WR,IDEVICE)
            CALL GRTERM(IDEVICE)
C
         X = (LEFT-8.0*HTLET*WR) *XPER + XADR
         Y = YSZDEF-16.0*HTLET*YPERIN-(IONPG)*HTPLOT*YPERIN/2.0
	 IF(Y .GT. YSZDEF-22.0*HTLET*YPERIN) Y=YSZDEF-22.0*HTLET*YPERIN
         CALL GRCHAR(IDEVICE,.FALSE.,90.0,.TRUE.,X,Y,SPH)
         CALL GRTERM(IDEVICE)
C
         END IF
         GO TO 951
      END IF
C
C
C     PAUSE IF PLOTTING ON TEK SCREEN
C
      IF(TYPE.EQ.3.AND.NEWPAGE) THEN
         CALL VISBEL
         NEWPAGE = .FALSE.
      END IF
C
C
C
C     SET UP PLOT AREA
C
      IONPG = IONPG + 1
      IONPG = MOD(IONPG,NPAGE)
      IF(IONPG.EQ.0) IONPG = NPAGE
      IF(IONPG.EQ.1) CALL GRPAGE(IDEVICE)
      YADD = (NPAGE-IONPG) * HTPLOT * YPERIN  
      CALL GRTRAN(IDEVICE,XADR,YADD,XPER,YPERIN)
C
C
      IPLAB = 0
      IF(IONPG.EQ.NPAGE.OR.NPLOT.EQ.NBP) IPLAB = 1
      CALL BORDER(RIGHT,LEFT,IPLAB,HTPLOT,BOT,HTTICK,HTLET,WR,IDEVICE)
      IF(IONPG.EQ.NPAGE.OR.NPLOT.EQ.NBP) THEN
         IF(TIMEA.EQ.HIHA) STIME = SIHA 
         IF(TIMEA.EQ.HGST) STIME = SGST
         IF(TIMEA.EQ.HUT.OR.TIMEA.EQ.HUTMOD) STIME = SUT
         CALL GRCHAR(IDEVICE,.FALSE.,0.0,.FALSE.,XCENTER-14.*HTLET*WR,
     +            BOT-3.5*HTLET,STIME)
C	write y-axis labels
         X = (LEFT-8.0*HTLET*WR) *XPER + XADR
         IF(IONPG.EQ.NPAGE) THEN
	   Y = YSZDEF/2.0 - 5.0*HTLET*YPERIN
	 ELSE
         Y = YSZDEF-9.0*HTLET*YPERIN-(IONPG)*HTPLOT*YPERIN/2.0
	 ENDIF
         Y = Y - 7.0*HTLET*YPERIN
	 IF(Y .GT. YSZDEF-22.0*HTLET*YPERIN) Y=YSZDEF-22.0*HTLET*YPERIN
         CALL GRCHAR(IDEVICE,.FALSE.,90.0,.TRUE.,X,Y,SPH)
C
      END IF
C
C
C					SCALE
      CALL CTICKS(RIGHT,LEFT,BOT,HTTICK,HTLET,HTPLOT,WR,PSCALE,IDEVICE)
C
      YLAB = BOT + HTPLOT - 2.5*HTLET
      XLAB = LEFT + 2.0*HTLET
      CALL VSTR(STLAB,2,STNAME(MB1(NPLOT)),STNAME(MB2(NPLOT)),0D0,0D0)
      CALL GRCHAR(IDEVICE,.FALSE.,0.0,.FALSE.,XLAB,YLAB,STLAB)
C
C				LABEL TOP OF PLOT
      IF(IONPG.EQ.1) THEN
         X = LEFT
         Y = BOT + HTPLOT
         CALL HLAB(X,Y,HTLET,SOURCE,MONTH,IDAY,IYEAR,FLUX,FREQ,IDEVICE)
C
C                                     Write file names and warnings
         IF(.NOT.NOTEXT) THEN
            CALL GRCHAR(IDEVICE,.FALSE.,90.0,.TRUE.,
     +               HTLET*1.5*XPERIN,HTLET*3.*YPERIN,WDATA)
            IF(MODEL) CALL GRCHAR(IDEVICE,.FALSE.,90.0,.TRUE.,
     +            HTLET*3.5*XPERIN,HTLET*3.*YPERIN,WMODEL)
            IF(TIMEA.EQ.HUTMOD.AND.MODEL.AND.UTMAX-UTMIN.GT.24.0) THEN      
              WWARN='Model and data will not coincide after first day.'
              WWARN(53:)='Use UT, GST, or IHA for match.'
              CALL GRCHAR(IDEVICE,.FALSE.,90.0,.FALSE.,
     +                   (XINMAX-HTLET)*XPERIN,HTLET*3.*YPERIN,WWARN)
            END IF          
         END IF                
      END IF
      CALL GRTERM(IDEVICE)	! Plot box etc. now
C
C     READ PHASES
C
  901    ND = 0
      NR = 0
      DO 905 ID = 1,MAXMOD
         READ(INDAT,END=950) IT,(TAKE(I),I=1,NWORDS)
         NR = NR + 1
         IF(IT.EQ.-1) GO TO 950
         UT = (IT-IZERO)/(60.*3600.)
         IF (UT.LT.UTMIN0) GO TO 905
         IF (UT.GT.UTMAX0) GO TO 905
         ND = ND + 1
         T(ND) = UT
         IUT(ND) = IT
         K = NDWPB*(IB-1)
         PHASE(ND,1) = TAKE(K+3)
         PHASE(ND,1) = PINCH(PHASE(ND,1))
C        USE PHASE(X,2) TO STORE ERRORS
         PHASE(ND,2) = TAKE(K+4)
  905    CONTINUE
C		Modified TJP 23-Mar-1983
  950	 IF (NR.NE.0) THEN
	    DO 918 ID=1,ND
                EBAR = PHASE(ID,2)
		IF (EBAR.EQ.0.0) GO TO 918
		IF ((.NOT.PLOTDEL).AND.(EBAR.LT.0.0)) GO TO 918
		IF (EBAR.GT.0.0) THEN
	            CALL GRSCI(COLOR(2))	! green
		ELSE
	            CALL GRSCI(2)		! red
		END IF
                IF (NOERR) EBAR = 0.0
		CALL ATIME(T(ID),TT,IB,1)
		X = XCENTER - (HR5 - TT) * INHRB
		CALL GRMOVA(X,(PHASE(ID,1)-EBAR)*INCHDG+YAD)
		CALL GRLINA(X,(PHASE(ID,1)+EBAR)*INCHDG+YAD)
  918	    CONTINUE
	    CALL GRSCI(COLOR(1))	! cyan
	    CALL GRTERM(IDEVICE)	! Plot data now
	END IF
C
      IF(NR.EQ.MAXMOD) GO TO 901
C
C     MODEL
C
      IF(MODEL) THEN
C
      IF (MB1(NPLOT).EQ.NPLTMS(1) .OR. MB2(NPLOT).EQ.NPLTMS(1)
     + .OR. MB1(NPLOT).EQ.NPLTMS(2) .OR. MB2(NPLOT).EQ.NPLTMS(2))
     +  GOTO 951
C
	 CALL GRSCI(COLOR(3)) 	! white
         MAX24 = .TRUE.
         IF(TIMEA.EQ.HUT) MAX24 = .FALSE.
         CALL MODCAL(INMOD,MB1(NPLOT),MB2(NPLOT),0,MAX24,MODPTS)
C        RETURN TIMING TO ORIGINAL AXIS UNITS
         CALL TIMING(TIMEA,TIMEC)
C
         IPEN = 13
C
C
         DO 818 IT = 1,MODPTS
         CALL ATIME(T(IT),TT,IB,1)
         IF(TT.LE.BTBMIN(NPLOT).OR.TT.GE.BTBMAX(NPLOT)) THEN
            IPEN = 13
            GO TO 818
         END IF
C
C            			BREAK LINE WHEN CROSSING 180 DEGREES
	 IF (IT.NE.1) THEN
            IF(ABS(PHASE(IT,1)-PHASE(IT-1,1)).GT.180.0) IPEN=13
         END IF
C
C					PLOT
         XX = XCENTER - (HR5-TT) * INHRB
         CALL SYSPLT(XX,PHASE(IT,1)*INCHDG+YAD,IPEN,IDEVICE)
            IPEN = 12
  818      CONTINUE
	 CALL GRSCI(COLOR(1))	! cyan
	 CALL GRTERM(IDEVICE)	! Plot model now
      END IF
C
  951 CONTINUE
      REWIND INDAT
      CALL HEADX20(SKIPH,INDAT,IDU,IDU,IDU,IDU,IDU,IDU,IDU,XDUM,IDU,IDU)
      IF(NPLOT.GE.NBP.AND..NOT.(DOCLOSE.OR.DOCLAMP)) GO TO 720
C
C
C     END OF BASELINE LOOP - RETURN FOR NEXT BASELINE
C
      IF(IONPG.EQ.NPAGE.OR.NPLOT.EQ.NBP) NEWPAGE = .TRUE.
      IF(NPLOT.GE.NBP) GO TO 720
      GO TO 780
C

