      SUBROUTINE ANGLUN (RANGE,UNIT,FACTOR)
C-----------------------------------------------------------------------
C Arguments:
C  RANGE (input, real): coordinate range
C  UNIT (output, character): units to use
C  FACTOR (output, real): scale factor to multiply coordinates by to
C      convert from degrees to UNIT.
C-----------------------------------------------------------------------
      IMPLICIT NONE
      CHARACTER*(*) UNIT
      REAL RANGE, FACTOR
C-----------------------------------------------------------------------
      IF (RANGE.LT.1/3600.) THEN
          UNIT = '(milliarcsec)'
          FACTOR = 3 600 000.
      ELSE IF (RANGE.LT.1/60.) THEN
          UNIT = '(arcsec)'
          FACTOR = 3600.
      ELSE IF (RANGE.LT.1.0) THEN
          UNIT = '(arcmin)'
          FACTOR = 60.0
      ELSE
          UNIT = '(degrees)'
          FACTOR = 1.0
      END IF
      RETURN
      END
