C*DRSORT -- indexed sort of real array into descending order
C+
      SUBROUTINE DRSORT(A,N,IND)
      INTEGER N
      REAL A(N)
      INTEGER IND(N)
C
C Indexed sort of a real array A into decreasing order. Shell sort.
C
C Array IND(N) is sorted so that IND(I) is the index of array A(N).
C-----------------------------------------------------------------------
      INTEGER IGAP, IMAX, I, J, JPLUSG, IEX
C
      IGAP=N
    5 IF(IGAP.LE.1) RETURN
      IGAP=IGAP/2
      IMAX=N-IGAP
   10     IEX=0
          DO 20 I=1,IMAX
          J=IND(I)
          JPLUSG=IND(I+IGAP)
          IF(A(J).LT.A(JPLUSG)) GOTO 40
          GOTO 20
   40     IND(I)=JPLUSG
          IND(I+IGAP)=J
          IEX=IEX+1
   20   CONTINUE
      IF(IEX.GT.0) GOTO 10
      GOTO 5
      END
