      SUBROUTINE FFREAD(RESULT,MAX,MODE,IN,OUT)
      INTEGER MAX, MODE, IN, OUT
      DOUBLE PRECISION RESULT(MAX)
C-----------------------------------------------------------------------
C               T.J.PEARSON  1978 MAY 11
C
C               FREE-FORMAT (LIST-DIRECTED) READ; UP TO 'MAX' ITEMS
C               ARE READ FROM THE INPUT AND RETURNED IN 'RESULT'.  THE
C               ITEMS ARE SEPARATED BY SPACE, COMMA OR END-OF-LINE,
C               AND THE LIST MAY BE TERMINATED BY '/'.  MODE=1 ON
C               INPUT REQUESTS REFLECTION OF INPUT; MODE RETURNS
C               0 IF '/' WAS FOUND, 1 IF EOF WAS FOUND, OR 2 IF
C               > MAX ITEMS WERE FOUND.
C-----------------------------------------------------------------------
      DOUBLEPRECISION KCTOR, KEXPRE
      INTEGER  ITEM, MAXREC, I, IS, IER
      CHARACTER COMMA,SLASH,SQUIRT
      CHARACTER*255 REC
      LOGICAL REFLEC
      INTEGER LEN1
      DATA COMMA/','/,SLASH/'/'/,SQUIRT/'!'/
C
      REFLEC=MODE.EQ.1
      ITEM=0
C
C               READ NEXT RECORD
C
   10 MAXREC=78
      READ (IN,400,END=350) REC
      MAXREC =LEN1(REC)
      IF (REFLEC) WRITE (OUT,420) REC(1:MAXREC)
      DO 15 I=1,MAXREC
      IF (REC(I:I).EQ.SQUIRT) THEN
          MAXREC = I-1
          IF (MAXREC.LT.1) GOTO 10
          GOTO 16
      END IF
   15 CONTINUE
   16 I=1
C
C               GET NEXT ITEM
C
   20 CALL KSKIPB(REC,I)
      IF (I.GT.MAXREC) GOTO 10
      IF (REC(I:I).EQ.SLASH) GOTO 340
      IF (ITEM.EQ.MAX) GOTO 360
      ITEM=ITEM+1
      IF (REC(I:I).EQ.COMMA) GOTO 40
      IS=I
      IF (REC(I:I).EQ.'(') THEN
          RESULT(ITEM) = KEXPRE(REC,I,IER)
          IF (IER.NE.0) THEN
                IF (.NOT.REFLEC) WRITE (OUT,420) REC(1:MAXREC)
                CALL ERROR('Illegal expression')
          END IF
      ELSE
          RESULT(ITEM) = KCTOR(REC,I)
      END IF
      IF (I.GT.IS) GOTO 30
                IF (.NOT.REFLEC) WRITE (OUT,420) REC(1:MAXREC)
                CALL ERROR('Illegal character')
                I=I+1
   30 CALL KSKIPB(REC,I)
      IF (I.GT.MAXREC) GOTO 10
   40 IF (REC(I:I).EQ.COMMA) I=I+1
      GOTO 20
C
C               TERMINATIONS
C
  340 MODE=0
      GOTO 370
  350 MODE=1
      GOTO 370
  360 MODE=2
  370 MAX=ITEM
      RETURN
C
C               FORMATS
C
  400 FORMAT(A)
  420 FORMAT(3X,A)
C
      END
