C*SCRNAM -- create a name for a scratch file [MS-DOS]
C+
      SUBROUTINE SCRNAM (TAG, NAME, L)
      CHARACTER*(*) TAG
      CHARACTER*(*) NAME
      INTEGER       L
C
C Create a name for a scratch file. This subroutine isolates an
C operating system dependency.
C
C On VMS, the name created is of the form
C "SYS$SCRATCH:tag.TMP" where "tag" is the supplied string.
C Note that NAME must be long enough to hold the result, i.e., 
C 16+LEN(TAG).
C 
C Arguments:
C  TAG    (input)  tag to be used to create the file name
C  NAME   (output) resulting file name
C  L      (output) number of significant characters in NAME.
C-----------------------------------------------------------------------
      CHARACTER*(*) SUFFIX
      PARAMETER (SUFFIX='.SCR')
      INTEGER  GETPID
C
      NAME = TAG//SUFFIX
      L = LEN(TAG) + LEN(SUFFIX) 
      IF (L.GT.LEN(NAME)) CALL ERROR('Bad arguments in SCRNAM')
      END
