#include <stdio.h>
#include <sgtty.h>

/* Read a single character from the user's terminal, without
   any interpretation */

int fgetchar_(val)	/* returns non-zero on error */
char *val;
{
	struct sgttyb tty;
	int save_flags, c;

	ioctl(0, TIOCGETP, &tty);
	save_flags = tty.sg_flags;
	tty.sg_flags = RAW;
	ioctl(0, TIOCSETP, &tty);
	tty.sg_flags = save_flags;
	/* getchar() returns next character from stdin */
	c = getchar();
	ioctl(0, TIOCSETP, &tty);
	if (c == EOF) {
	    *val = 0;
	    return EOF;
	    }
	else {
	    *val = c & 127;
	    return 0;
	    }
}
