C*RDFITC -- read one block from a disk FITS file [Convex-UNIX]
C+
      SUBROUTINE RDFITC (UNIT, IER, BLOCK)
      INTEGER UNIT
      INTEGER IER
      CHARACTER*2880 BLOCK
C
C Input parameters:
C   UNIT : I/O unit number to be used
C
C Output parameters:
C   IER : receives 0 if OK, > 0 on error, < 0 on EOF
C   BLOCK : receives the next 2880-byte block from the file
C
C This routine is the same as RDFITS, but returns the FITS data in
C a character variable instead of an integer array.
C-----------------------------------------------------------------------
      INTEGER BLKNO
      COMMON /FITS2/ BLKNO
C
      BLKNO = BLKNO+1
      READ (UNIT=UNIT, IOSTAT=IER, REC=BLKNO) BLOCK
C     For Convex, convert "non-existent record" to "end-of-file"
      IF (IER.EQ.134) IER = -1
      IF (IER.GT.0) CALL PERROR('FITS read error')
C-----------------------------------------------------------------------
      END
