	SUBROUTINE CTRLCEN
C-----------------------------------------------------------------------
C CTRLCEN and CTRLCAST are Fortran routines that let you set up a
C Control-C handling facility.
C
C Call CTRLCEN to enable the next control-C typed on the keyboard
C to activate the CTRLCAST AST handler.  CTRLCAST sets the common
C flag CCFLAG in common /CONTRC/, which may be tested by your
C program.
C
C You must call CTRLCEN each time you want to allow a control-C input.
C
C These programs do not affect the handling of control-Y.
C The logical name "TT" is translated to find your terminal. If
C TT is not a terminal, a warning message will be written on
C SYS$OUTPUT and the AST will not be set up.
C
C  7-Dec-1981 - M. Ewing.
C  3-Jan-1985 - revised for VAX/VMS Fortran V4.0 [TJP].
C-----------------------------------------------------------------------
	IMPLICIT NONE
	INCLUDE  '($IODEF)'
	INTEGER  ICHAN, ISTAT, L, SYS$ASSIGN, SYS$QIOW
	CHARACTER*80 MESSAGE
	LOGICAL  CCFLAG
	COMMON   /CONTRC/ CCFLAG
	EXTERNAL CTRLCAST
C
	CCFLAG = .FALSE.
	ISTAT  =  SYS$ASSIGN('TT', ICHAN, , )
	IF (.NOT.ISTAT) GOTO 100
	ISTAT =  SYS$QIOW(,%VAL(ICHAN), 
     1       %VAL(IO$_SETMODE.OR.IO$M_CTRLCAST),,,,CTRLCAST,,,,,)
	IF (.NOT.ISTAT) GOTO 100
	RETURN
C
  100	CALL LIB$SYS_GETMSG(ISTAT,L,MESSAGE)
	CALL LIB$PUT_OUTPUT(MESSAGE(:L))
	RETURN
	END

	SUBROUTINE CTRLCAST (ARG)
C-----------------------------------------------------------------------
C AST handler set up by CTRLCEN.
C-----------------------------------------------------------------------
	IMPLICIT NONE
	INTEGER ARG(5)
	LOGICAL CCFLAG
	COMMON  /CONTRC/ CCFLAG
	CCFLAG = .TRUE.
	RETURN
	END
