C*DATTIM -- return current date and time [VAX/VMS]
C+
      SUBROUTINE DATTIM (STRING)
      CHARACTER*(*) STRING
C
C Return the current date and time in a character string in standard
C format: 'dd-MMM-yyyy hh:mm:ss'. The caller can request the full
C string, by supplying a string of length 20 characters, or just the
C date, by supplying a string of length 11 characters.
C
C Argument:
C  STRING  (output) : receives the date and time, or string '<unknown>'
C                    if the information is not available; should be
C                    either 11 characters or 20 characters.
C
C Subroutines required:
C  LIB$DATE_TIME (VMS)
C
C History:
C  1987 Nov 17 - TJP.
C-----------------------------------------------------------------------
      INTEGER IER, L
      INTEGER LIB$DATE_TIME
C
      STRING = ' '
      L = MIN(20,LEN(STRING))
      IER = LIB$DATE_TIME(STRING(:L))
      IF (.NOT.IER) STRING = '<unknown>'
C
      END
