C*NODENM -- return name of current host (node) [VAX/VMS]
C+
      SUBROUTINE NODENM (NODE)
      CHARACTER*(*) NODE
C
C Return the name of the current host (node).
C
C Argument:
C  NODE   (output) : receives the node name, or string '<unknown>' if
C                    information is not available.
C
C Subroutines required:
C  LIB$SYS_TRNLOG (VMS).
C
C History:
C  1987 Nov 12 - TJP.
C-----------------------------------------------------------------------
      INTEGER K, L, IER, LIB$SYS_TRNLOG
      CHARACTER*12 X
C
C Look for a translation of SYS$NODE in the SYSTEM logical name table.
C
      IER = LIB$SYS_TRNLOG('SYS$NODE',L,X,,,6)
      IF (.NOT.IER) THEN
          NODE = '?'
      ELSE
          IF (X(L:L).EQ.':') L = L-1
          IF (X(L:L).EQ.':') L = L-1
          K = 1
          IF (X(K:K).EQ.'_') K = K+1
          NODE = X(K:L)
      END IF
C
      END
