*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*
* Include file for VLBGRD                                                    *
* The gridder uses a small convolution in the u-v plane NCELS eavh side      *
* of the given u-v point. The gridding function is tabled in PSF             *
* NPCEL sub-divisions to a grid point of u-v. The grid correction function(s)*
* are tabled in HOOK(KBCORX) and HOOK(KBCORY)                                *
* Extensixe tabling of the interior loops of the gridder is then done on the *
* first pass through GRDSET. The tables LOOK, LOOKPU, LOOKPV provide the     *
* necessary information to GRID and DEGRID                                   *
* I do not advise changing this code without discussing it with me first     *
* S.F. Gull 13 December 1989, CIT                                            *
*----------------------------------------------------------------------------*
      INTEGER NCELS,NPCEL,NPTS,N2CELS,VGRDSZ
      PARAMETER (NCELS=3)
      PARAMETER (N2CELS=(2*NCELS)**2)
      PARAMETER (NPCEL=256)
      PARAMETER (NPTS=NCELS*NPCEL)
      PARAMETER (VGRDSZ=1+2*NPTS+2+3*N2CELS)
      COMMON /VLBGRD/ HOOK(1),PSF(2*NPTS+1),LOOK(N2CELS),
     *      LOOKPU(N2CELS),LOOKPV(N2CELS),KBCORX,KBCORY
