C Deimos version of FOUR1
      SUBROUTINE FOUR1(DATA,N,ISIGN1,IFORM)
      COMPLEX DATA(*),DATA1(1)
      INTEGER N(*)
      INCLUDE 'FOURSG.INC'
      EQUIVALENCE (XWORK(1),DATA1(1))
      ISIGN=-ISIGN1
      IF (IFORM) 70,20,20
   20 CONTINUE
      NCURR=N(1)
      IF (IFORM) 30,30,40
 30   NCURR=NCURR/2
 40   IF (NREV.NE.NCURR) CALL BITRV (NCURR)
      NREV=NCURR
      DO 3 J=1,NCURR
3     DATA1(J)=DATA(IREV(J))
      CALL CT1D (NCURR,ISIGN)
      DO 1 J=1,NCURR
      DATA(J)=DATA1(J)
    1 CONTINUE
      IF (IFORM) 50,50,60
 50   CALL FIXRL (DATA,N(1),ISIGN,IFORM)
   60 CONTINUE
      RETURN
 70   CONTINUE
      NCURR=N(1)
 80   NCURR=NCURR/2
      CALL FIXRL (DATA,N(1),ISIGN,IFORM)
      IF(NREV.NE.NCURR) CALL BITRV(NCURR)
      NREV=NCURR
      DO 4 J=1,NCURR
    4 DATA1(J)=DATA(IREV(J))
      CALL CT1D (NCURR,ISIGN)
      DO 2 J=1,NCURR
    2 DATA(J)=DATA1(J)
      RETURN
      END

      SUBROUTINE FIXRL (DATA,N,ISIGN,IFORM)
      REAL DATA(*)
      INCLUDE 'FOURSG.INC'
      INTEGER NLAST
      SAVE NLAST
      DATA NLAST/0/
      IF((N*ISIGN).EQ.NLAST) GO TO 10
      NLAST=ISIGN*N
      TWOPI=6.283185307*FLOAT(ISIGN)
 90   THETA=TWOPI/FLOAT(N)
      SINTH=SIN(THETA/2.)
      ZSTPR=-2.*SINTH*SINTH
      ZSTPI=SIN(THETA)
      ZR(2)=(1.-ZSTPI)/2.
      ZI(2)=(1.+ZSTPR)/2.
      IF (IFORM) 100,110,110
 100  ZR(2)=1.-ZR(2)
      ZI(2)=-ZI(2)
  110 CONTINUE
      N5=N/4+1
      DO 91 J=2,N5
      ZR(J+1)=ZSTPR*(ZR(J)-0.5)-ZSTPI*ZI(J)+ZR(J)
   91 ZI(J+1)=ZSTPR*ZI(J)+ZSTPI*(ZR(J)-0.5)+ZI(J)
   10 CONTINUE
      TEMPR=DATA(1)
      DATA(1)=DATA(1)+DATA(2)
      DATA(2)=TEMPR-DATA(2)
      N9=2*(N/2+1)
      DO 180 I1=2,N5
      I2=2*I1-1
      I2CNJ=N9-I2
      IF(I2-I2CNJ) 150,120,120
  120 IF(IFORM) 170,180,180
 150  DIFR=DATA(I2)-DATA(I2CNJ)
      DIFI=DATA(I2+1)+DATA(I2CNJ+1)
      TEMPR=DIFR*ZR(I1)-DIFI*ZI(I1)
      TEMPI=DIFR*ZI(I1)+DIFI*ZR(I1)
      DATA(I2)=DATA(I2)-TEMPR
      DATA(I2+1)=DATA(I2+1)-TEMPI
      DATA(I2CNJ)=DATA(I2CNJ)+TEMPR
      DATA(I2CNJ+1)=DATA(I2CNJ+1)-TEMPI
      IF (IFORM) 160,180,180
 160  DATA(I2CNJ)=DATA(I2CNJ)+DATA(I2CNJ)
      DATA(I2CNJ+1)=DATA(I2CNJ+1)+DATA(I2CNJ+1)
 170  DATA(I2)=DATA(I2)+DATA(I2)
      DATA(I2+1)=DATA(I2+1)+DATA(I2+1)
 180  CONTINUE
 270  RETURN
      END

      SUBROUTINE BITRV(N)
      INCLUDE 'FOURSG.INC'
      I4REV=1
      DO 61 J=1,N
   61 IREV(J)=J
      DO 60 I4=1,N
      IF(I4-I4REV)10,30,30
   10 CONTINUE
      IREV(I4)=I4REV
   20 IREV(I4REV)=I4
   30 IP2=N/2
   40 IF(I4REV-IP2)60,60,50
   50 I4REV=I4REV-IP2
      IP2=IP2/2
      IF(IP2-1)60,40,40
   60 I4REV=I4REV+IP2
      RETURN
      END
C
C       Sorry to be unsophisticated
C       I have faster Fouriers than this
C       which you will recognise as a direct pinch
C       from COOL2 by N Brenner.
C
C       But at least it works.
C
       SUBROUTINE CT1D(N,ISIGN)
C
      INCLUDE 'FOURSG.INC'
      COMPLEX DATA(1),TEMP,WSTP,W,W2,W3,T0,T1,T2,T3
      EQUIVALENCE (XWORK(1),DATA(1))
      TWOPI=6.28318530717958647692*FLOAT(ISIGN)
      IP0=1
      IP1=IP0
      IP4=IP1*N
      IP5=IP4
      IP2=IP1
      NPART=N
   10 IF(NPART-2)50,30,20
   20 NPART=NPART/4
      GO TO 10
C
C      DO A FOURIER TRANSFORM OF LENGTH TWO
C
   30 IP3=IP2*2
      I1MAX=IP1
      DO 40 I1=1,I1MAX,IP0
      DO 40 I5=I1,IP5,IP3
      I3A=I5
      I3B=I3A+IP2
      TEMP=DATA(I3B)
      DATA(I3B)=DATA(I3A)-TEMP
   40 DATA(I3A)=DATA(I3A)+TEMP
      GO TO 140
C
C      DO A FOURIER TRANSFORM OF LENGTH FOUR (WITHOUT BIT REVERSAL)
C
   50 IP3=IP2*4
      THETA=TWOPI/FLOAT(IP3/IP1)
      SINTH=SIN(THETA/2.)
      WSTP=CMPLX(-2.*SINTH*SINTH,SIN(THETA))
C
C      COS(THETA)-1, FOR ACCURACY
C
      W=1.
      DO 130 I2=1,IP2,IP1
      IF(I2-1)70,70,60
   60 W2=W*W
      W3=W2*W
   70 I1MAX=I2+IP1-IP0
      DO 120 I1=I2,I1MAX,IP0
      DO 120 I5=I1,IP5,IP3
      I3A=I5
      I3B=I3A+IP2
      I3C=I3B+IP2
      I3D=I3C+IP2
      IF(I2-1)90,90,80
C
C      MULTIPLY BY THE PHASE SHIFT FACTORS
C
   80 DATA(I3B)=W2*DATA(I3B)
      DATA(I3C)=W*DATA(I3C)
      DATA(I3D)=W3*DATA(I3D)
   90 T0=DATA(I3A)+DATA(I3B)
      T1=DATA(I3A)-DATA(I3B)
      T2=DATA(I3C)+DATA(I3D)
      T3=DATA(I3C)-DATA(I3D)
      DATA(I3A)=T0+T2
      DATA(I3C)=T0-T2
      TEMP=(0.,1.)*T3
      IF(ISIGN)100,100,110
  100 TEMP=-TEMP
  110 DATA(I3B)=T1+TEMP
  120 DATA(I3D)=T1-TEMP
  130 W=W*WSTP+W
  140 IP2=IP3
      IF(IP3-IP4)50,150,150
  150 RETURN
      END
