      SUBROUTINE FITS_MWRIT (STATUS)
C-----------------------------------------------------------------------
C     Writes the main FITS buffer, FBUFF, into the disk file.
C
C     Parameters -   (">" input, "<" output)
C
C     (<) STATUS     (Integer) Returned status code.  0 => OK,
C                    non-zero values are I/O error codes which can be
C                    decoded by FITS_ERROR.
C
C     Common variables used -
C
C     (>) MTUNIT     (Integer) The Fortran unit used for output.
C     (>) FBUFF      (Byte array) The main FITS buffer.
C
C                                             KS / CIT 9th Oct 1983
C-----------------------------------------------------------------------
C
      INTEGER STATUS
C
      INCLUDE 'fits1.inc'
C
      WRITE  (UNIT=MTUNIT, REC=BLKNO, IOSTAT=STATUS) FBUFF
      BLKNO = BLKNO + 1
C
      END
