C        INCLUDE FILE FOR VLBPLOT TO PLOT CLOSURE PHASES.
C
C
      IF(CSCALE.EQ.0.0) THEN
         INCHDG = HTPLOT / 360.0
      ELSE
         INCHDG = HTPLOT / (2.0*CSCALE)
      END IF
C
      IF(TIMEA.NE.TIMEC.OR.NBP.EQ.0)
     +CALL TSCALE(CTMIN,CTMAX,INHRC,LEFTC,RIGHTC,MAXWID,MINWID,HR5C,
     +             TIMEC,XCENTER)
      IF(TIMEA.NE.TIMEC.OR.NBP.EQ.0) GO TO 33
         INHRC = INHRB
         RIGHTC = RIGHT
         LEFTC = LEFT
         HR5C = HR5
   33 CONTINUE
      IF(TIMEC.EQ.HGST) INHRC = INHRC*SIDR
C     
C     FOR TEK SCREENS - SPREAD SCALE TO FILL SCREEN
C    
      WR = 1.0
      XPER = XPERIN
      XADR = 0.0
      IF(TYPE.EQ.3) THEN
         WID = RIGHTC - LEFTC
         WR = WID/MAXWID
         XPER = XPERIN / WR
         XADR = (XPERIN - XPER)*XCENTER
      END IF
C
      IF(SETWIDTH) THEN
	 WID = RIGHTC - LEFTC
	 WR = WID/SETW
         XPER = XPERIN / WR
         XADR = (XPERIN - XPER)*XCENTER
      END IF
C
C
      NPLOT = 0
      IF (IONPG+1 .EQ. NPAGE) ONEPAGE=.FALSE.
      IF (ONEPAGE) THEN
       IONPG = IONPG+1
       IONPGO = IONPG
      ELSE
       IONPG = 0
      ENDIF
C
  190 NPLOT = NPLOT + 1
      DO 195 IC = 1,NC
         IF(MC1(NPLOT).EQ.NC1(IC).AND.MC2(NPLOT).EQ.NC2(IC)
     +     .AND.MC3(NPLOT).EQ.NC3(IC)) GO TO 197
  195 CONTINUE
      WRITE(6,1195) MC1(NPLOT),MC2(NPLOT),MC3(NPLOT)
 1195 FORMAT('0 Closure phase (',I2,',',I2,',',I2,') not found')
      STOP
C
  197 CONTINUE
      IF(UTCMIN(NPLOT).EQ.9999.) THEN
         WRITE(6,1196) MC1(NPLOT),MC2(NPLOT),MC3(NPLOT)
 1196    FORMAT(' No data for closure phase (',I2,',',I2,',',I2,') ')
         IF(NPLOT.EQ.NCP.AND.IONPG.NE.NPAGE.AND.IONPG.GT.0 .AND.
     + 	  .NOT.(ONEPAGE.AND.(IONPG.EQ.IONPGO))) THEN
            IF(TIMEC.EQ.HGST) STIME = SGST
            IF(TIMEC.EQ.HUT.OR.TIMEC.EQ.HUTMOD) STIME = SUT
            CALL GRCHAR(IDEVICE,.FALSE.,0.0,.FALSE.,
     +          XCENTER-15.*HTLET*WR,BOT-3.5*HTLET,STIME)
            IPLAB = 1
            CALL BORDER(RIGHTC,LEFTC,IPLAB,HTPLOT,BOT,
     +                  HTTICK,HTLET,WR,IDEVICE)
            CALL GRTERM(IDEVICE)
C
           X = (LEFTC-6.*HTLET*WR)*XPER + XADR
	  IF (ONEPAGE) THEN
	   YOFSET=IONPGO*HTPLOT*YPERIN
	   YOFCEN=(IONPG-IONPGO)*HTPLOT*YPERIN/2
	   Y = YSZDEF-YOFSET-YOFCEN-12*HTLET*YPERIN
	  ELSE
           Y = YSZDEF-16.0*HTLET*YPERIN-(IONPG)*HTPLOT*YPERIN/2.0
	  ENDIF
 	  IF(Y .GT. YSZDEF-21.0*HTLET*YPERIN) Y=YSZDEF-21.0*HTLET*YPERIN
	  IF (Y .LT. 0.0) Y=0.0
          CALL GRCHAR(IDEVICE,.FALSE.,90.0,.TRUE.,X,Y,SCLPH)
          CALL GRTERM(IDEVICE)
C
         END IF
         GO TO 239
      END IF
C  
C  
C     PAUSE IF PLOTTING ON TEK SCREEN
C
      IF(TYPE.EQ.3.AND.NEWPAGE .AND. .NOT.ONEPAGE) THEN
         CALL VISBEL
         NEWPAGE = .FALSE.
      END IF
C
C
C     SET UP PLOT AREA
C
      IONPG = IONPG + 1
      IONPG = MOD(IONPG,NPAGE)
      IF(IONPG.EQ.0) IONPG = NPAGE
      IF(IONPG.EQ.1) CALL GRPAGE(IDEVICE)
      YADD = (NPAGE-IONPG) * HTPLOT * YPERIN  
      CALL GRTRAN(IDEVICE,XADR,YADD,XPER,YPERIN)
C
C
C
C      PLOT BORDERS AND LABELS FOR CLOSURE PHASE PLOTS
C
      IPLAB = 0
      IF(IONPG.EQ.NPAGE.OR.NPLOT.EQ.NCP) IPLAB = 1
      CALL BORDER(RIGHTC,LEFTC,IPLAB,HTPLOT,BOT,HTTICK,HTLET,WR,IDEVICE)
C
      IF(IONPG.EQ.NPAGE.OR.NPLOT.EQ.NCP)  THEN
         IF(TIMEC.EQ.HGST) STIME = SGST
         IF(TIMEC.EQ.HUT.OR.TIMEC.EQ.HUTMOD) STIME = SUT
         CALL GRCHAR(IDEVICE,.FALSE.,0.0,.FALSE.,XCENTER-15.*HTLET*WR,
     +                BOT-3.5*HTLET,STIME)
C
         X = (LEFTC-6.*HTLET*WR)*XPER + XADR
	IF(IONPG.EQ.NPAGE .AND. .NOT.ONEPAGE) THEN
         Y = YSZDEF/2.0  - 12.0*HTLET*YPERIN
	ELSE
	  IF (ONEPAGE) THEN
	   YOFSET=IONPGO*HTPLOT*YPERIN
	   YOFCEN=(IONPG-IONPGO)*HTPLOT*YPERIN/2
	   Y = YSZDEF-YOFSET-YOFCEN-12*HTLET*YPERIN
	  ELSE
           Y = YSZDEF-16.0*HTLET*YPERIN-(IONPG)*HTPLOT*YPERIN/2.0
	  ENDIF
	 IF(Y .GT. YSZDEF-21.0*HTLET*YPERIN) Y=YSZDEF-21.0*HTLET*YPERIN
	 IF (Y .LT. 0.0) Y=0.0
	ENDIF
         CALL GRCHAR(IDEVICE,.FALSE.,90.0,.TRUE.,X,Y,SCLPH)
C
      END IF
C
      Y = BOT
      YLAB = BOT + HTPLOT - 2.5*HTLET
      CALL CTICKS(RIGHTC,LEFTC,Y,HTTICK,HTLET,HTPLOT,WR,CSCALE,IDEVICE)
      XLAB = LEFTC + 2.0*HTLET
      CALL VSTR(STLAB,3,STNAME(MC1(NPLOT)),STNAME(MC2(NPLOT)),
     +          STNAME(MC3(NPLOT)), 0D0)
      CALL GRCHAR(IDEVICE,.FALSE.,0.0,.FALSE.,XLAB,YLAB,STLAB)
C
      IF(IONPG.EQ.1 .OR. (ONEPAGE.AND.(IONPG.EQ.IONPGO+1))) THEN
         X = LEFTC
         Y = BOT + HTPLOT
         CALL HLAB(X,Y,HTLET,SOURCE,MONTH,IDAY,IYEAR,FLUX,FREQ,IDEVICE)
C
C                                     Write file names and warnings
         IF(.NOT.NOTEXT .AND. .NOT.ONEPAGE) THEN
            CALL GRCHAR(IDEVICE,.FALSE.,90.0,.TRUE.,
     +               HTLET*1.5*XPERIN,HTLET*3.*YPERIN,WDATA)
            IF(MODEL) CALL GRCHAR(IDEVICE,.FALSE.,90.0,.TRUE.,
     +            HTLET*3.5*XPERIN,HTLET*3.*YPERIN,WMODEL)
            IF(TIMEC.EQ.HUTMOD.AND.MODEL.AND.UTMAX-UTMIN.GT.24.0) THEN      
              WWARN='Model and data will not coincide after first day.'
              WWARN(53:)='Use UT, GST, or IHA for match.'
              CALL GRCHAR(IDEVICE,.FALSE.,90.0,.FALSE.,
     +                   (XINMAX-HTLET)*XPERIN,HTLET*3.*YPERIN,WWARN)
            END IF          
         END IF                
      END IF
      CALL GRTERM(IDEVICE)	! Plot box etc. now
C
C     DATA   CLOSURE PHASE
C
  401 ND = 0
      NR = 0
C     READ CLOSURE PHASES
      DO 405 ID = 1,MAXMOD
         READ(INDAT,END=450) IT,(TAKE(I),I=1,NWORDS)
         NR = NR + 1
         IF(IT.EQ.-1) GO TO 450
         UT = (IT-IZERO)/(60.*3600.)
         IF (UT.LT.UTMIN0) GO TO 405
         IF (UT.GT.UTMAX0) GO TO 405
         ND = ND + 1
         T(ND) = UT
         IUT(ND) = IT
         K = NDWPB*NB + 2*(IC-1)
         CLOS(ND) = TAKE(K+1)
         CLOS(ND) = PINCH(CLOS(ND))
         AMP(ND,2)  = TAKE(K+2)
  405    CONTINUE
C		Modified TJP 23-Mar-1983
  450	 IF (NR.NE.0) THEN
	    DO 238 ID = 1,ND
                EBAR = AMP(ID,2)
		IF (EBAR.EQ.0.0) GO TO 238
		IF ((.NOT.PLOTDEL).AND.(EBAR.LT.0.0)) GO TO 238
		IF (EBAR.GT.0.0) THEN
	            CALL GRSCI(COLOR(2))	! green
		ELSE
	            CALL GRSCI(2)		! red
		END IF
                IF (NOERR) EBAR = 0.0
		CALL CCTIME(T(ID),TT)
		X = XCENTER - (HR5C-TT)*INHRC
		CALL GRMOVA(X,(CLOS(ID)-EBAR)*INCHDG+YAD)
		CALL GRLINA(X,(CLOS(ID)+EBAR)*INCHDG+YAD)
  238	    CONTINUE
	    CALL GRSCI(COLOR(1))	! cyan
	    CALL GRTERM(IDEVICE)	! Plot data now
	END IF
C
      IF(NR.EQ.MAXMOD) GO TO 401
C
C     MODEL
C
      IF(.NOT.MODEL) GO TO 140
C
      IF (MC1(NPLOT).EQ.NPLTMS(1) .OR. MC2(NPLOT).EQ.NPLTMS(1) 
     + .OR. MC3(NPLOT).EQ.NPLTMS(1) .OR. MC1(NPLOT).EQ.NPLTMS(2) 
     + .OR. MC2(NPLOT).EQ.NPLTMS(2) .OR. MC3(NPLOT).EQ.NPLTMS(2))
     + GOTO 140
C
	 CALL GRSCI(COLOR(3))	! white
         MAX24 = .TRUE.
         IF(TIMEC.EQ.HUT) MAX24 = .FALSE.
       CALL MODCAL(INMOD,MC1(NPLOT),MC2(NPLOT),MC3(NPLOT),MAX24,MODPTS)
C        RETURN TIMING TO ORIGINAL AXIS UNITS
         CALL TIMING(TIMEA,TIMEC)
C
         IPEN = 13
         DO 138 IT = 1,MODPTS
            CALL CCTIME(T(IT),TT)
            IF(TT.GT.CTCMIN(NPLOT).AND.TT.LT.CTCMAX(NPLOT)) GO TO 137
               IPEN = 13
               GO TO 138
  137      CONTINUE
            IF(IT.NE.1) THEN
               IF(ABS(CLOS(IT)-CLOS(IT-1)).GT.180.0) IPEN = 13
            END IF
            XX = XCENTER - (HR5C - TT)*INHRC
            CALL SYSPLT(XX,CLOS(IT)*INCHDG+YAD,IPEN,IDEVICE)
            IPEN = 12
  138       CONTINUE
	    CALL GRSCI(COLOR(1))		! cyan
	    CALL GRTERM(IDEVICE)	! Plot model now
  140    CONTINUE
C
  239 CONTINUE
      REWIND INDAT
      CALL HEADX20(SKIPH,INDAT,IDU,IDU,IDU,IDU,IDU,IDU,IDU,XDUM,IDU,IDU)
      IF(NPLOT.GE.NCP.AND..NOT.DOCLAMP) GO TO 241
C
C
C     END OF TRIANGLES LOOP - RETURN FOR NEXT TRIANGLE
C
      IF(IONPG.EQ.NPAGE.OR.NPLOT.EQ.NCP) THEN
	NEWPAGE = .TRUE.
	ONEPAGE = .FALSE.
      ENDIF
      IF(NPLOT.GE.NCP) GO TO 241
      GO TO 190
