$!----------------------------------------------------------------------
$!  This procedure tests the programs GPS, PHFITS, and FITSLIST using
$!  PHASOR data.
$!
$!  T. J. Pearson, 1985 Feb 22.
$!----------------------------------------------------------------------
$!
$ PROC = F$ENVIRONMENT("PROCEDURE")
$ NAME = F$PARSE(PROC,,,"NAME","SYNTAX_ONLY")
$!
$ SET DEFAULT SYS$SCRATCH
$ ON WARNING THEN GOTO EXIT
$!
$ GPS
input = cit:[ext1...]*.fpr
listfile = SYS$SCRATCH:{name}.gps_list
/
$ PHFITS
input = cit:[ext1...]*.fpr
output = phfits.uvf
source = "3C273"
stations = "IOWA", "OVRO"
/
$ FITSLIST
input = phfits.uvf
listfile = SYS$SCRATCH:{name}.fitslist_list
/
$ DELETE/NOCONFIRM/LOG PHFITS.UVF;*
$ PRINT/HOLD -
	'PROC',-
	SYS$SCRATCH:'NAME'.GPS_LIST,-
	SYS$SCRATCH:'NAME'.FITSLIST_LIST
$ EXIT: EXIT
