$!----------------------------------------------------------------------
$! VMS library builder.
$!----------------------------------------------------------------------
$!
$ LIB = "VLBLIB.OLB"
$!
$ COMPILE: SUBROUTINE
$   FORT'P2' 'P1'.f /OBJECT='P1'.obj
$   LIBRARY/REPLACE/LOG 'LIB' 'P1'.obj
$   DELETE/NOCONFIRM 'P1'.obj;*
$ ENDSUBROUTINE
$!
$ MACRO: SUBROUTINE
$   MACRO'P2' 'P1'.mar /OBJECT='P1'.obj
$   LIBRARY/REPLACE/LOG 'LIB' 'P1'.obj
$   DELETE/NOCONFIRM 'P1'.obj;*
$ ENDSUBROUTINE
$!
$ WRITE SYS$OUTPUT "Compiling ", LIB
$ LIBRARY/CREATE/LOG 'LIB'
$ CALL COMPILE anglun
$ CALL COMPILE besj0
$ CALL COMPILE besj1
$ CALL COMPILE chsort
$ CALL COMPILE [.sys_vms]ctrlcen
$ CALL COMPILE [.sys_vms]dattim
$ CALL COMPILE dbesj0
$ CALL COMPILE dbesj1
$ CALL COMPILE drsort
$ CALL COMPILE ebcasc
$ CALL COMPILE [.sys_vms]error
$ CALL COMPILE [.sys_vms]ffiles
$ CALL COMPILE ffread
$ CALL COMPILE filter
$ CALL COMPILE fitin
$ CALL COMPILE fitkey
$ CALL MACRO   [.sys_vms]fits_bswap
$ CALL COMPILE [.sys_vms]fits_ieeer4
$ CALL MACRO   [.sys_vms]fits_wbswap
$ CALL COMPILE four2
$ CALL COMPILE [.sys_vms]frdt
$ CALL COMPILE gconvl
$ CALL COMPILE geoid
$ CALL COMPILE [.sys_vms]getcom
$ CALL COMPILE getdig
$ CALL COMPILE [.sys_vms]getin
$ CALL COMPILE getnum
$ CALL COMPILE gtmodl
$ CALL COMPILE headx15
$ CALL COMPILE headx20
$ CALL COMPILE headx30
$ CALL COMPILE headx40
$ CALL COMPILE [.sys_vms]isterm
$ CALL COMPILE julda
$ CALL COMPILE kctod
$ CALL COMPILE kctoi
$ CALL COMPILE kctor
$ CALL COMPILE kexpre
$ CALL COMPILE keychk
$ CALL COMPILE keycmp
$ CALL COMPILE keyfnd
$ CALL COMPILE keyhlp
$ CALL COMPILE keyin
$ CALL COMPILE keymap
$ CALL COMPILE keyout
$ CALL COMPILE keyput
$ CALL COMPILE [.sys_vms]kpack
$ CALL COMPILE [.sys_vms]krdlin
$ CALL COMPILE kskipb
$ CALL COMPILE kword
$ CALL COMPILE len1
$ CALL COMPILE lookup
$ CALL COMPILE median
$ CALL COMPILE mkhist
$ CALL COMPILE mrgsiz
$ CALL COMPILE [.sys_vms]narrow
$ CALL COMPILE [.sys_vms]newfil
$ CALL COMPILE [.sys_vms]nodenm
$ CALL COMPILE nxtwrd
$ CALL COMPILE pangle
$ CALL COMPILE parseb
$ CALL COMPILE pgellip
$ CALL COMPILE phsamp
$ CALL COMPILE prfreq
$ CALL COMPILE [.sys_vms]prognm
$ CALL COMPILE [.sys_vms]putout
$ CALL COMPILE query
$ CALL COMPILE ran5
$ CALL COMPILE [.sys_vms]rclock
$ CALL COMPILE [.sys_vms]rdfitc
$ CALL COMPILE [.sys_vms]rdfits
$ CALL COMPILE rdline
$ CALL COMPILE rdsrc
$ CALL COMPILE rdsta
$ CALL COMPILE repcpu
$ CALL COMPILE report
$ CALL COMPILE rngaus
$ CALL COMPILE [.sys_vms]sclock
$ CALL COMPILE [.sys_vms]scrnam
$ CALL COMPILE sort
$ CALL MACRO   [.sys_vms]sqread
$ CALL COMPILE srcpan
$ CALL COMPILE sspace
$ CALL COMPILE stnabr
$ CALL COMPILE swap
$ CALL COMPILE [.sys_vms]symsub
$ CALL COMPILE [.sys_vms]sysver
$ CALL COMPILE tdate
$ CALL COMPILE tform
$ CALL COMPILE timec
$ CALL COMPILE [.sys_vms]tsttty
$ CALL COMPILE upcase
$ CALL COMPILE [.sys_vms]usernm
$ CALL COMPILE [.sys_vms]valloc
$ CALL COMPILE [.sys_vms]visbel
$ CALL COMPILE [.sys_vms]vlbope
$ CALL COMPILE [.sys_vms]vmshlp
$ CALL COMPILE [.sys_vms]zr32rl
$ CALL MACRO   [.sys_vms]zr64rl
$ CALL MACRO   [.sys_vms]zrlr64
$ CALL COMPILE absv
$ CALL COMPILE atan3
$ CALL COMPILE atanh
$ CALL COMPILE cartes
$ CALL COMPILE cbrt
$ CALL COMPILE conic
$ CALL COMPILE dot
$ CALL COMPILE ellem
$ CALL COMPILE ellme
$ CALL COMPILE hypem
$ CALL COMPILE hypme
$ CALL COMPILE icfind
$ CALL COMPILE kepler
$ CALL COMPILE propgat
$ CALL COMPILE taxyz
$ CALL COMPILE vcomb
$ CALL COMPILE vcross
$ CALL COMPILE vequal
$ CALL COMPILE vunit
$
$ PURGE/LOG 'LIB'
