      PROGRAM ORBTST
C1    IMPLICIT NONE
      DOUBLE PRECISION PI,RPDEG,DIURN,TWOPI
      PARAMETER  (PI=3.141592653589793 D0)
      PARAMETER  (RPDEG=PI/180.D0)
      PARAMETER  (DIURN=360D0/365.25D0)
      PARAMETER  (TWOPI=2D0*PI)
C
      INTEGER I
      DOUBLE PRECISION AEIOWM(6),RE,GM,HJ2,DT,D0,TA,TIME,RHST(6)
      DOUBLE PRECISION AEIP(6),TAP
      COMMON /EARTH/ RE,GM,HJ2
      DATA D0/0D0/, RE/6370000./, GM/3.986012D14/, HJ2/1.083D-3/
      TIME = D0
C       DO I=1,6
C         WRITE (6,'(8H$AEIOWM(,I1,3H)? )') I
C         READ  (5,'(F10.2)') AEIOWM(I)
C       END DO
      READ (5,*) AEIOWM
      AEIOWM(1) = AEIOWM(1)*1D3
C                    ! METERS
      DO 10 I=3,6
          AEIOWM(I) = AEIOWM(I)*RPDEG
   10 CONTINUE
C
      CALL CARTES(RHST,GM,AEIOWM(1),AEIOWM(2),
     1    AEIOWM(3),AEIOWM(4),AEIOWM(5),
     2    AEIOWM(6))
      CALL KEPLER (TA,'TRUE',AEIOWM(2),AEIOWM(6),'MEAN')
      IF (TA.GT.PI) TA = TA - TWOPI
C
      CALL CONIC(AEIP(1),AEIP(2),AEIP(3),
     1    AEIP(4),AEIP(5),AEIP(6),
     2    GM,RHST)
      CALL KEPLER (TAP,'TRUE',AEIP(2),AEIP(6),'MEAN')
      IF (TAP.GT.PI) TAP = TAP - TWOPI
C
      WRITE (6,'(F9.2,F9.1,F9.6,4F9.3,6F9.2)') TIME/86400.D0,
     1    AEIOWM(1)/1D3, AEIOWM(2), TA/RPDEG, AEIOWM(5)/RPDEG,
     2    AEIOWM(3)/RPDEG, AEIOWM(4)/RPDEG-DIURN*TIME/86400.D0,
     3    RHST(1)/1D3, RHST(2)/1D3, RHST(3)/1D3, RHST(4)/1D3,
     4    RHST(5)/1D3, RHST(6)/1D3
      WRITE (6,'(9X,F9.1,F9.6,4F9.3,/)')
     1    AEIP(1)/1D3, AEIP(2), TAP/RPDEG, AEIP(5)/RPDEG,
     2    AEIP(3)/RPDEG, AEIP(4)/RPDEG-DIURN*TIME/86400.D0
      DT = 86400.D0
      DO 30 I=1,100
          TIME = TIME + DT
          CALL PROPGAT(AEIOWM,DT)
C
          CALL CARTES(RHST,GM,AEIOWM(1),AEIOWM(2),
     1      AEIOWM(3),AEIOWM(4),AEIOWM(5),
     2      AEIOWM(6))
          CALL KEPLER (TA,'TRUE',AEIOWM(2),AEIOWM(6),'MEAN')
          IF (TA.GT.PI) TA = TA - TWOPI
C
          CALL CONIC(AEIP(1),AEIP(2),AEIP(3),
     1      AEIP(4),AEIP(5),AEIP(6),
     2      GM,RHST)
          CALL KEPLER (TAP,'TRUE',AEIP(2),AEIP(6),'MEAN')
          IF (TAP.GT.PI) TAP = TAP - TWOPI
C
          WRITE (6,'(F9.2,F9.1,F9.6,4F9.3,6F9.2)') TIME/86400.D0,
     1      AEIOWM(1)/1D3, AEIOWM(2), TA/RPDEG, AEIOWM(5)/RPDEG,
     2      AEIOWM(3)/RPDEG, AEIOWM(4)/RPDEG-DIURN*TIME/86400.D0,
     3      RHST(1)/1D3, RHST(2)/1D3, RHST(3)/1D3, RHST(4)/1D3,
     4      RHST(5)/1D3, RHST(6)/1D3
          WRITE (6,'(9X,F9.1,F9.6,4F9.3,/)')
     1      AEIP(1)/1D3, AEIP(2), TAP/RPDEG, AEIP(5)/RPDEG,
     2      AEIP(3)/RPDEG, AEIP(4)/RPDEG-DIURN*TIME/86400.D0
   30 CONTINUE
      STOP
      END
