C*REPCPU -- report cpu time and elapsed time on output
C+
      SUBROUTINE REPCPU (UNIT)
      INTEGER UNIT
C
C REPCPU generates a report of cpu time, elapsed time,
C etc. on a specified Fortran unit. SCLOCK must have been called
C previously to start the clock.
C
C Argument:
C   UNIT   (input)  : the Fortran unit to which output is to be
C                     written (formatted).
C-----------------------------------------------------------------------
      CHARACTER*11 BUFFER
      REAL         CPU
C
   10 FORMAT (A,' time:',T20,F8.1,' sec')
   20 FORMAT (A,' time:',T20,A)
C
      CALL RCLOCK(BUFFER, CPU)
      WRITE (UNIT,10) 'CPU', CPU
      WRITE (UNIT,20) 'Elapsed', BUFFER
C
      END
