C*DATTIM -- return current date and time [Alliant-UNIX]
C+
      SUBROUTINE DATTIM (STRING)
      CHARACTER*(*) STRING
C
C Return the current date and time in a character string in standard
C format: 'dd-MMM-yyyy hh:mm:ss'. The caller can request the full
C string, by supplying a string of length 20 characters, or just the
C date, by supplying a string of length 11 characters.
C
C Argument:
C  STRING  (output) : receives the date and time, or string '<unknown>'
C                    if the information is not available; should be
C                    either 11 characters or 20 characters.
C
C Subroutines required:
C  DATE, TIME (Convex)
C
C History:
C  1988 Apr 2 - TJP.
C  1989 Sep 5 - RAG, ALF, Modified to use FDATE on the Alliant
C-----------------------------------------------------------------------
      CHARACTER*24 D
      CHARACTER*24 FDATE 
C
      D = FDATE( )
      STRING = D(9:10)//'-'//D(5:7)//'-'//D(21:24)//' '//D(12:19)
      END
