C*FFILES -- expand wild cards in file name [Convex-UNIX]
C+
      SUBROUTINE FFILES(INPUT, NMAX, RESULT, NFOUND)
      CHARACTER*(*) INPUT
      INTEGER NMAX
      CHARACTER*(*) RESULT(NMAX)
      INTEGER NFOUND
C
C Expand wild cards in file name.
C
C INPUT : input file name
C NMAX  : input maximum number of files
C RESULT: output array of names of matching files
C NFOUND: output number of files found
C
C 28-Nov-1988
C-----------------------------------------------------------------------
      CHARACTER*(*) TEMP
      PARAMETER (TEMP='/tmp/find_file.tmp')
      INTEGER IER
      INTEGER UNLINK, SYSTEM
      CHARACTER*255 COMMND
C
C Generate list in TEMP.
C
      IER = UNLINK(TEMP)
      COMMND = 'ls -1d >'//TEMP//' '//INPUT
      IER = SYSTEM(COMMND)
      OPEN (UNIT=49, FILE=TEMP, STATUS='OLD')
C
C Read the list.
C
      NFOUND = 0
      DO I=1,NMAX
          READ (49, '(A)', END=10) COMMND
          NFOUND = NFOUND+1
          RESULT(NFOUND) = COMMND
      END DO
   10 CLOSE (UNIT=49)
C
C Delete the temporary file.
C
      IER = UNLINK(TEMP)
      END
