C*FFILES -- expand wild cards in file name [VAX/VMS]
C+
      SUBROUTINE FFILES(INPUT, NMAX, RESULT, NFOUND)
      CHARACTER*(*) INPUT
      INTEGER NMAX
      CHARACTER*(*) RESULT(NMAX)
      INTEGER NFOUND
C
C Expand wild cards in file name.
C
C INPUT : input file name
C NMAX  : input maximum number of files
C RESULT: output array of names of matching files
C NFOUND: output number of files found
C
C-----------------------------------------------------------------------
      INTEGER CONTXT, IER, L
      INTEGER LIB$FIND_FILE
      CHARACTER*255 OUTPUT
      INTEGER RMS$_NMF
      PARAMETER (RMS$_NMF = '000182CA'X)
C
      NFOUND = 0
      CONTXT = 0
   20 IER = LIB$FIND_FILE(INPUT,OUTPUT,CONTXT)
      IF (IER.EQ.RMS$_NMF) GOTO 10
      IF (.NOT.IER) THEN
          CALL LIB$SYS_GETMSG(IER,L,OUTPUT)
          CALL PUTOUT(OUTPUT(1:L))
          GOTO 10
      END IF
      IF (NFOUND.GE.NMAX) GOTO 10
      NFOUND = NFOUND+1
      RESULT(NFOUND) = OUTPUT
      GOTO 20
   10 RETURN
      END
