C*RCLOCK -- get elapsed real time and cpu time [VAX/VMS]
C+
      SUBROUTINE RCLOCK (ELAPSE, CPU)
      CHARACTER*(*) ELAPSE
      REAL CPU     
C
C Return elapsed time and cpu time used since preceding call to SCLOCK.
C
C Arguments:
C   ELAPSE (output) : elapsed time (character string)
C   CPU    (output) : cpu time (in seconds)
C
C Subroutines required:
C   LIB$STAT_TIMER (VMS)
C   SYS$ASCTIM (VMS)
C
C History:
C   1988 Jun  9 - TJP.
C-----------------------------------------------------------------------
      REAL*8 SYSTIM
      INTEGER IT
C
      CALL LIB$STAT_TIMER(1,SYSTIM)
      CALL SYS$ASCTIM(,ELAPSE,SYSTIM,%VAL(1))
      CALL LIB$STAT_TIMER(2,IT)
      CPU = FLOAT(IT)/100.0
      RETURN
      END
