C*RDFITS -- read one block from a disk FITS file [VMS]
C+
      SUBROUTINE RDFITS (UNIT, IER, BLOCK)
      INTEGER UNIT
      INTEGER IER
      INTEGER BLOCK(720)
C
C Input parameters:
C   UNIT : I/O unit number to be used
C
C Output parameters:
C   IER : receives 0 if OK, > 0 on error, < 0 on EOF
C   BLOCK : receives the next 2880-byte block from the file
C-----------------------------------------------------------------------
      INTEGER BLKNO
      COMMON /FITS2/ BLKNO
C
      BLKNO = BLKNO+1
      READ (UNIT=UNIT, IOSTAT=IER, REC=BLKNO) BLOCK
C     -- Change "non-existent record" to "end-of-file"
      IF (IER.EQ.36) IER = -1
C-----------------------------------------------------------------------
      END
