C*SYSVER -- return name and version number of operating system [VAX/VMS]
C+
      SUBROUTINE SYSVER (STRING)
      CHARACTER*(*) STRING
C
C Return the name and version number of the operating system.
C
C Argument:
C  STRING  (output) : receives the information, or string '<unknown>' if
C                    it is not available.
C
C Subroutines required:
C  LEN1
C  LIB$GETSYI (VMS)
C
C History:
C  1987 Nov 17 - TJP.
C-----------------------------------------------------------------------
      INTEGER IER1, IER2, L1, L2
      INTEGER LIB$GETSYI, LEN1
      EXTERNAL SYI$_NODE_HWTYPE, SYI$_VERSION
      CHARACTER*8   OPSYS, CPU
C
C VMS cpu type.
C
      IER1 = LIB$GETSYI(%LOC(SYI$_NODE_HWTYPE),,CPU,L1)
C
C VMS operating system version.
C
      IER2 = LIB$GETSYI(%LOC(SYI$_VERSION),,OPSYS,L2)
C
      IF (IER1 .AND. IER2) THEN
          STRING = CPU(1:L1)//', VMS '//OPSYS(:LEN1(OPSYS(:L2)))
      ELSE
          STRING = '<unknown>'
      END IF
C
      END
