C-----------------------------------------------------------------------
C mefits.inc
C-----------------------------------------------------------------------
C Parameters obtained from input file that are used to create the
C header of output images.
C
      CHARACTER*16 HOBSER
C                          observer name
      CHARACTER*16 HTELES
C                          telescope name
      CHARACTER*16 HSNAME
C                          source name
      CHARACTER*8  HDATOB
C                          data of observation (dd/mm/yy)
      REAL         HEPOCH
C                          epoch of coordinates
      REAL         HFREQ
C                          frequency (Hz)
      DOUBLE PRECISION HRA0, HDEC0
C                          map center (radians)
      REAL         HXINT, HYINT
C                          cell size (degrees)
      COMMON /MEFIT1/ HOBSER, HTELES, HSNAME, HDATOB
      COMMON /MEFIT2/ HRA0, HDEC0, HXINT, HYINT, HEPOCH, HFREQ
C-----------------------------------------------------------------------
