      SUBROUTINE FITS_WBSWAP (ARRAY,LWORDS)
      INTEGER*4 ARRAY(*), TEMP
      INTEGER LWORDS, I
C 
C 	Exchanges the byte order in an array of 32 bit longwords
C        so that it matches the convention used by non-DEC
C 	machines.  This is based on an MTPCKG routine written
C 	by Bill Sebok.  
C 
C 	Parameters -    (">" input, "!" modified, "<" output)
C 
C 	(!) ARRAY    (Integer*4 array ARRAY(LWORDS)) The array
C 		     to be swapped.
C 	(>) LWORDS   (Integer) The number of longwords in ARRAY
C 
C 	Subroutines / functions used - None
C 
C                                    KS / CIT 11th Oct 1983
C       RLM version for Linux/PCs (swap code from SCA routine)
C-----------------------------------------------------------------------
        DO I = 1, LWORDS
              TEMP  = ARRAY(I)
              ARRAY(I) = IAND (ISHFT(TEMP,-24),255)
              ARRAY(I) = IOR (ARRAY(I), IAND( ISHFT(TEMP,-8),65280))
              ARRAY(I) = IOR (ARRAY(I), ISHFT(IAND(TEMP,65280), 8))
              ARRAY(I) = IOR (ARRAY(I), ISHFT(IAND(TEMP,255), 24))  
        END DO
      RETURN
      END
